package explorviz.live_trace_processing.filter.reduction;

import explorviz.live_trace_processing.Constants;
import explorviz.live_trace_processing.filter.AbstractFilter;
import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.record.IRecord;
import explorviz.live_trace_processing.record.misc.TerminateRecord;
import explorviz.live_trace_processing.record.misc.TimedPeriodRecord;
import explorviz.live_trace_processing.record.trace.Trace;

public abstract class AbstractReductionFilter extends AbstractFilter implements ITraceReduction {

	public AbstractReductionFilter(final IPipeReceiver receiver, final String counterString) {
		super(receiver, Constants.TRACE_SUMMARIZATION_DISRUPTOR_SIZE,
				Constants.TRACE_SUMMARIZATION_OUTPUT_BUFFER_SIZE, counterString);
	}

	public Trace testReduction(final Trace trace) {
		return reduceTrace(trace);
	}

	@Override
	protected void processRecord(final IRecord record) {
		if (record instanceof Trace) {
			final Trace trace = (Trace) record;
			if (trace.isValid()) {
				final Trace reducedTrace = reduceTrace(trace);
				deliver(reducedTrace);
			} else {
				deliver(trace);
			}
		} else if (record instanceof TimedPeriodRecord) {
			periodicFlush(record);
			deliver(record);
		} else if (record instanceof TerminateRecord) {
			System.out.println("terminate...");
			deliver(record);
		} else {
			deliver(record);
		}
	}

	protected abstract Trace reduceTrace(Trace trace);

}
